diff --git a/src/dwg.c b/src/dwg.c
index a6167a3..411dc99 100644
--- a/src/dwg.c
+++ b/src/dwg.c
@@ -13,7 +13,7 @@
 /**
  *     \file       dwg.c
  *     \brief      Main functions and API
- *     \author     written by Felipe Castro
+ *     \author     written and modified by Felipe Castro
  *     \author     modified by Felipe Corrêa da Silva Sances
  *     \author     modified by Rodrigo Rodrigues da Silva
  *     \author     modified by Anderson Pierre Cardoso
@@ -27,14 +27,19 @@
 #include <string.h>
 #include <sys/stat.h>
 
+#include "dwg.h"
 #include "bits.h"
 #include "common.h"
 #include "decode.h"
-#include "dwg.h"
 #include "logging.h"
 
+/* TODO: update with new codes */
+/** DWG version codes */
+char version_codes[8][7] =
+  { "------", "AC1012", "AC1014", "AC1015", "AC1018", "AC1021", "AC1024", "------" };
+
 int
-dwg_read_file(char *filename, Dwg_Data *dwg_data)
+dwg_read_file (char *filename, Dwg_Data * dwg_data)
 {
   int sign;
   FILE *fp;
@@ -42,114 +47,116 @@ dwg_read_file(char *filename, Dwg_Data *dwg_data)
   size_t size;
   Bit_Chain bit_chain;
 
-  if (stat(filename, &attrib))
+  if (stat (filename, &attrib))
     {
-      LOG_ERROR("File not found: %s \n", filename)
-      return -1;
+      LOG_ERROR ("File not found: %s \n", filename) return -1;
     }
   if (!S_ISREG (attrib.st_mode))
     {
-      LOG_ERROR("Error: %s \n", filename)
-      return -1;
+      LOG_ERROR ("Error: %s \n", filename) return -1;
     }
-  fp = fopen(filename, "rb");
+  fp = fopen (filename, "rb");
   if (!fp)
     {
-      LOG_ERROR("Could not open file: %s\n", filename)
-      return -1;
+      LOG_ERROR ("Could not open file: %s\n", filename) return -1;
     }
 
   /* Load file to memory */
   bit_chain.bit = 0;
   bit_chain.byte = 0;
   bit_chain.size = attrib.st_size;
-  bit_chain.chain = (unsigned char *) malloc(bit_chain.size);
+  bit_chain.chain = (unsigned char *) malloc (bit_chain.size);
   if (!bit_chain.chain)
     {
-      LOG_ERROR("Not enough memory.\n")
-      fclose(fp);
+      LOG_ERROR ("Not enough memory.\n") fclose (fp);
       return -1;
     }
   size = 0;
-  size = fread(bit_chain.chain, sizeof(char), bit_chain.size, fp);
+  size = fread (bit_chain.chain, sizeof (char), bit_chain.size, fp);
   if (size != bit_chain.size)
     {
-      LOG_ERROR("Could not read the entire file (%lu out of %lu): %s \n",
-                (long unsigned int) size, bit_chain.size, filename)
-      fclose(fp);
-      free(bit_chain.chain);
+      LOG_ERROR ("Could not read the entire file (%lu out of %lu): %s \n",
+		 (long unsigned int) size, bit_chain.size, filename)
+	fclose (fp);
+      free (bit_chain.chain);
       return -1;
     }
-  fclose(fp);
+  fclose (fp);
 
   /* Decode the dwg structure */
   dwg_data->bit_chain = &bit_chain;
 
-  if (dwg_decode_data(&bit_chain, dwg_data))
+  if (dwg_decode_data (&bit_chain, dwg_data))
     {
-      LOG_ERROR("Failed to decode file: %s \n", filename)
-      free(bit_chain.chain);
+      LOG_ERROR ("Failed to decode file: %s \n", filename)
+	free (bit_chain.chain);
       return -1;
     }
-  free(bit_chain.chain);
+  free (bit_chain.chain);
 
   return 0;
 }
 
+char *
+dwg_version_code (Dwg_Data * dwg)
+{
+  if (dwg->header.version > R_BEFORE && dwg->header.version < R_AFTER)
+    return (version_codes[dwg->header.version]);
+  else
+    return ("UNKNOW");
+}
 
 /* if write support is enabled */
-#ifdef USE_WRITE 
+#ifdef USE_WRITE
 
 int
-dwg_write_file(char *filename, Dwg_Data *dwg_data)
+dwg_write_file (char *filename, Dwg_Data * dwg_data)
 {
   FILE *dt;
   struct stat atrib;
   Bit_Chain bit_chain;
-  bit_chain.version = (Dwg_Version_Type)dwg_data->header.version;
-
-   /* Encode the DWG struct */
-   bit_chain.size = 0;
-   if (dwg_encode_chains (dwg_data, &bit_chain))
-     {
-       LOG_ERROR("Failed to encode datastructure.\n")
-       if (bit_chain.size > 0)
-       free (bit_chain.chain);
-       return -1;
-     }
-
-   /* try opening the output file in write mode */
-   if (!stat (filename, &atrib))
-     {
-       LOG_ERROR("The file already exists. We won't overwrite it.")
-       return -1;
-     }
-   dt = fopen (filename, "w");
-   if (!dt)
-     {
-       LOG_ERROR("Failed to create the file: %s\n", filename)
-       return -1;
-     }
-  
-   /* Write the data into the file */
-   if (fwrite (bit_chain.chain, sizeof (char), bit_chain.size, dt) != bit_chain.size)
-     {
-       LOG_ERROR("Failed to write data into the file: %s\n", filename)
-       fclose (dt);
-       free (bit_chain.chain);
-       return -1;
-     }
-   fclose (dt);
-
-   if (bit_chain.size > 0)
-   free (bit_chain.chain);
+  bit_chain.version = (Dwg_Version_Type) dwg_data->header.version;
+
+  /* Encode the DWG struct */
+  bit_chain.size = 0;
+  if (dwg_encode_chains (dwg_data, &bit_chain))
+    {
+      LOG_ERROR ("Failed to encode datastructure.\n") if (bit_chain.size > 0)
+	free (bit_chain.chain);
+      return -1;
+    }
+
+  /* try opening the output file in write mode */
+  if (!stat (filename, &atrib))
+    {
+      LOG_ERROR ("The file already exists. We won't overwrite it.") return -1;
+    }
+  dt = fopen (filename, "w");
+  if (!dt)
+    {
+      LOG_ERROR ("Failed to create the file: %s\n", filename) return -1;
+    }
+
+  /* Write the data into the file */
+  if (fwrite (bit_chain.chain, sizeof (char), bit_chain.size, dt) !=
+      bit_chain.size)
+    {
+      LOG_ERROR ("Failed to write data into the file: %s\n", filename)
+	fclose (dt);
+      free (bit_chain.chain);
+      return -1;
+    }
+  fclose (dt);
+
+  if (bit_chain.size > 0)
+    free (bit_chain.chain);
 
   return 0;
 }
-#endif /* USE_WRITE */ 
+#endif /* USE_WRITE */
 
 unsigned char *
-dwg_bmp(Dwg_Data *stk, long int *size)
+dwg_bmp (Dwg_Data * stk, long int *size)
 {
   char num_pictures;
   char code;
@@ -158,179 +165,171 @@ dwg_bmp(Dwg_Data *stk, long int *size)
   long int header_size;
   Bit_Chain *dat;
 
-  dat = (Bit_Chain*) &stk->picture;
+  dat = (Bit_Chain *) & stk->picture;
   dat->bit = 0;
   dat->byte = 0;
 
-  bit_read_RL(dat);
-  num_pictures = bit_read_RC(dat);
-  LOG_INFO("num_pictures: %i \n", num_pictures)
-
-  *size = 0;
+  bit_read_RL (dat);
+  num_pictures = bit_read_RC (dat);
+  LOG_INFO ("num_pictures: %i \n", num_pictures) * size = 0;
   plene = 0;
   header_size = 0;
   for (i = 0; i < num_pictures; i++)
     {
-      code = bit_read_RC(dat);
-      LOG_TRACE("\t%i - Code: %i \n", i, code)
-      LOG_TRACE("\t\t Adress: 0x%lx \n", bit_read_RL (dat))
-      bit_read_RL(dat);
+      code = bit_read_RC (dat);
+      LOG_TRACE ("\t%i - Code: %i \n", i, code)
+	LOG_TRACE ("\t\t Adress: 0x%lx \n", bit_read_RL (dat))
+	bit_read_RL (dat);
       if (code == 1)
-        {
-          header_size += bit_read_RL(dat);
-          LOG_TRACE("\t\t Header size: %li \n", header_size)
-        }
+	{
+	  header_size += bit_read_RL (dat);
+	LOG_TRACE ("\t\t Header size: %li \n", header_size)}
       else if (code == 2 && plene == 0)
-        {
-          *size = bit_read_RL(dat);
-          plene = 1;
-          LOG_TRACE("\t\t BMP size: %li \n", *size)
-        }
+	{
+	  *size = bit_read_RL (dat);
+	  plene = 1;
+	LOG_TRACE ("\t\t BMP size: %li \n", *size)}
       else if (code == 3)
-        {
-          bit_read_RL(dat);
-          LOG_TRACE("\t\t WMF size: 0x%lx \n", bit_read_RL (dat))
-        }
+	{
+	  bit_read_RL (dat);
+	LOG_TRACE ("\t\t WMF size: 0x%lx \n", bit_read_RL (dat))}
       else
-        {
-          bit_read_RL(dat);
-          LOG_TRACE("\t\t Size: 0x%lx \n", bit_read_RL (dat))
-        }
+	{
+	  bit_read_RL (dat);
+	LOG_TRACE ("\t\t Size: 0x%lx \n", bit_read_RL (dat))}
     }
   dat->byte += header_size;
-  LOG_TRACE("Current adress: 0x%lx \n", dat->byte)
-
-  if (*size > 0)
+  LOG_TRACE ("Current adress: 0x%lx \n", dat->byte) if (*size > 0)
     return (dat->chain + dat->byte);
   else
     return NULL;
 }
 
 double
-dwg_model_x_min(Dwg_Data *dwg)
+dwg_model_x_min (Dwg_Data * dwg)
 {
   return dwg->header_vars.EXTMIN_MSPACE.x;
 }
 
 double
-dwg_model_x_max(Dwg_Data *dwg)
+dwg_model_x_max (Dwg_Data * dwg)
 {
   return dwg->header_vars.EXTMAX_MSPACE.x;
 }
 
 double
-dwg_model_y_min(Dwg_Data *dwg)
+dwg_model_y_min (Dwg_Data * dwg)
 {
   return dwg->header_vars.EXTMIN_MSPACE.y;
 }
 
 double
-dwg_model_y_max(Dwg_Data *dwg)
+dwg_model_y_max (Dwg_Data * dwg)
 {
   return dwg->header_vars.EXTMAX_MSPACE.y;
 }
 
 double
-dwg_model_z_min(Dwg_Data *dwg)
+dwg_model_z_min (Dwg_Data * dwg)
 {
   return dwg->header_vars.EXTMIN_MSPACE.z;
 }
 
 double
-dwg_model_z_max(Dwg_Data *dwg)
+dwg_model_z_max (Dwg_Data * dwg)
 {
   return dwg->header_vars.EXTMAX_MSPACE.z;
 }
 
 double
-dwg_page_x_min(Dwg_Data *dwg)
+dwg_page_x_min (Dwg_Data * dwg)
 {
   return dwg->header_vars.EXTMIN_PSPACE.x;
 }
 
 double
-dwg_page_x_max(Dwg_Data *dwg)
+dwg_page_x_max (Dwg_Data * dwg)
 {
   return dwg->header_vars.EXTMAX_PSPACE.x;
 }
 
 double
-dwg_page_y_min(Dwg_Data *dwg)
+dwg_page_y_min (Dwg_Data * dwg)
 {
   return dwg->header_vars.EXTMIN_PSPACE.y;
 }
 
 double
-dwg_page_y_max(Dwg_Data *dwg)
+dwg_page_y_max (Dwg_Data * dwg)
 {
   return dwg->header_vars.EXTMAX_PSPACE.y;
 }
 
 unsigned int
-dwg_get_layer_count(Dwg_Data *dwg)
+dwg_get_layer_count (Dwg_Data * dwg)
 {
   return dwg->layer_control->as.object->as.LAYER_CONTROL->num_entries;
 }
 
 Dwg_Object_LAYER **
-dwg_get_layers(Dwg_Data *dwg)
+dwg_get_layers (Dwg_Data * dwg)
 {
   int i;
-  Dwg_Object_LAYER **layers = (Dwg_Object_LAYER **) malloc(
-		               dwg_get_layer_count(dwg) *
-                               sizeof (Dwg_Object_LAYER*));
-  for (i=0; i < dwg_get_layer_count(dwg); i++)
+  Dwg_Object_LAYER **layers =
+    (Dwg_Object_LAYER **) malloc (dwg_get_layer_count (dwg) *
+				  sizeof (Dwg_Object_LAYER *));
+  for (i = 0; i < dwg_get_layer_count (dwg); i++)
     {
-      layers[i] = dwg->layer_control->as.object->as.LAYER_CONTROL->
-                  layers[i]->obj->as.object->as.LAYER;
+      layers[i] =
+	dwg->layer_control->as.object->as.LAYER_CONTROL->layers[i]->obj->as.object->as.LAYER;
     }
   return layers;
 }
 
 long unsigned int
-dwg_get_object_count(Dwg_Data *dwg)
+dwg_get_object_count (Dwg_Data * dwg)
 {
   return dwg->num_objects;
 }
 
 long unsigned int
-dwg_get_object_object_count(Dwg_Data *dwg)
+dwg_get_object_object_count (Dwg_Data * dwg)
 {
   return dwg->num_objects - dwg->num_entities;
 }
 
 long unsigned int
-dwg_get_entity_count(Dwg_Data *dwg)
+dwg_get_entity_count (Dwg_Data * dwg)
 {
   return dwg->num_entities;
 }
 
 Dwg_Object_Entity **
-dwg_get_entities(Dwg_Data *dwg)
+dwg_get_entities (Dwg_Data * dwg)
 {
   long unsigned int i, ent_count = 0;
-  Dwg_Object_Entity **entities = (Dwg_Object_Entity **) malloc(
-                                  dwg_get_entity_count(dwg) *
-                                  sizeof (Dwg_Object_Entity*));
-  for (i=0; i < dwg->num_objects; i++)
+  Dwg_Object_Entity **entities =
+    (Dwg_Object_Entity **) malloc (dwg_get_entity_count (dwg) *
+				   sizeof (Dwg_Object_Entity *));
+  for (i = 0; i < dwg->num_objects; i++)
     {
       if (dwg->object[i].supertype == DWG_SUPERTYPE_ENTITY)
-        {
-          entities[ent_count] = dwg->object[i].as.entity;
-          ent_count++;
-        }
+	{
+	  entities[ent_count] = dwg->object[i].as.entity;
+	  ent_count++;
+	}
     }
   return entities;
 }
 
 Dwg_Object_LAYER *
-dwg_get_entity_layer(Dwg_Object_Entity *ent)
+dwg_get_entity_layer (Dwg_Object_Entity * ent)
 {
   return ent->layer->obj->as.object->as.LAYER;
 }
 
-Dwg_Object*
-dwg_next_object(Dwg_Object *obj)
+Dwg_Object *
+dwg_next_object (Dwg_Object * obj)
 {
   if ((obj->index + 1) > obj->parent->num_objects - 1)
     return 0;
@@ -338,7 +337,7 @@ dwg_next_object(Dwg_Object *obj)
 }
 
 int
-dwg_get_object(Dwg_Object *obj, Dwg_Object_Ref *ref)
+dwg_get_object (Dwg_Object * obj, Dwg_Object_Ref * ref)
 {
   if (ref->obj)
     {
@@ -348,8 +347,8 @@ dwg_get_object(Dwg_Object *obj, Dwg_Object_Ref *ref)
   return -1;
 }
 
-Dwg_Object*
-get_first_owned_object(Dwg_Object *hdr_obj, Dwg_Object_BLOCK_HEADER *hdr)
+Dwg_Object *
+get_first_owned_object (Dwg_Object * hdr_obj, Dwg_Object_BLOCK_HEADER * hdr)
 {
   unsigned int version = hdr_obj->parent->header.version;
 
@@ -365,31 +364,31 @@ get_first_owned_object(Dwg_Object *hdr_obj, Dwg_Object_BLOCK_HEADER *hdr)
     }
 }
 
-Dwg_Object*
-get_next_owned_object(Dwg_Object* hdr_obj, Dwg_Object* current,
-                      Dwg_Object_BLOCK_HEADER* hdr)
+Dwg_Object *
+get_next_owned_object (Dwg_Object * hdr_obj, Dwg_Object * current,
+		       Dwg_Object_BLOCK_HEADER * hdr)
 {
   unsigned int version = hdr_obj->parent->header.version;
 
   if (R_13 <= version && version <= R_2000)
     {
-      if (current == hdr->last_entity->obj) 
-        return 0;
-      return dwg_next_object(current);
+      if (current == hdr->last_entity->obj)
+	return 0;
+      return dwg_next_object (current);
     }
 
   if (version >= R_2004)
     {
       hdr->__iterator++;
       if (hdr->__iterator == hdr->owned_object_count)
-        return 0;
+	return 0;
       return hdr->entities[hdr->__iterator]->obj;
     }
 }
 
 void
-dwg_free(Dwg_Data *dwg)
+dwg_free (Dwg_Data * dwg)
 {
   if (dwg->header.section)
-    free(dwg->header.section);
+    free (dwg->header.section);
 }
diff --git a/src/dwg.h b/src/dwg.h
index 1cc17e8..5c4c3aa 100644
--- a/src/dwg.h
+++ b/src/dwg.h
@@ -13,7 +13,7 @@
 /**
  *     \file       dwg.h
  *     \brief      Main include file
- *     \author     written by Felipe Castro
+ *     \author     written and modified by Felipe Castro
  *     \author     modified by Felipe Corrêa da Silva Sances
  *     \author     modified by Rodrigo Rodrigues da Silva
  *     \author     modified by Till Heuschmann
@@ -21,6 +21,7 @@
  *     \copyright  GNU General Public License (version 3 or later)
  */
 
+
 #ifndef DWG_H
 #define DWG_H
 
@@ -31,7 +32,7 @@
 
 #define BITCODE_DOUBLE double
 
-#define BITCODE_RC char
+#define BITCODE_RC unsigned char
 #define FORMAT_RC "%2x"
 #define BITCODE_MC long int
 #define FORMAT_MC "%l"
@@ -115,6 +116,29 @@ typedef struct _dwg_bitecode_3bd
 #define BITCODE_3DPOINT BITCODE_3BD
 
 /**
+ *    \enum    DWG_VERSION_TYPE
+ *    \brief   Version for the dwg data spec
+ */
+typedef enum DWG_VERSION_TYPE
+{
+  R_BEFORE=0, R_13, R_14, R_2000, R_2004, R_2007, R_2010, R_AFTER
+} Dwg_Version_Type;
+extern char version_codes[8][7];
+
+/**
+ *    \struct  _bit_chain
+ *    \brief   Bit chain of encoded dwg data
+ */
+typedef struct _bit_chain
+{
+  unsigned char *chain;
+  long unsigned int size;
+  long unsigned int byte;
+  unsigned char bit;
+  Dwg_Version_Type version;
+} Bit_Chain;
+
+/**
  *    \enum    DWG_OBJECT_SUPERTYPE
  *    \brief   Object supertypes that exist in dwg-files
  */
@@ -2858,18 +2882,6 @@ typedef struct _dwg_class
 } Dwg_Class;
 
 /**
- *    \struct  _dwg_chain
- *    \brief   Dwg_Chain same as Bit_Chain in "bits.h"
- */
-typedef struct _dwg_chain
-{
-  unsigned char *chain;
-  long unsigned int size;
-  long unsigned int byte;
-  unsigned char bit;
-} Dwg_Chain;
-
-/**
  *    \struct  _dwg_section
  *    \brief   Struct for DWG section
  */
@@ -2929,7 +2941,7 @@ typedef struct _dwg_struct
 {
   struct
   {
-    unsigned int version;
+    Dwg_Version_Type version;
     unsigned int codepage;
     unsigned int num_sections;
     Dwg_Section* section;
@@ -2938,9 +2950,9 @@ typedef struct _dwg_struct
   } header;
 
   #define DWG_UNKNOWN1_SIZE 123
-  Dwg_Chain unknown1;
+  Bit_Chain unknown1;
 
-  Dwg_Chain picture;
+  Bit_Chain picture;
 
   Dwg_Header_Variables header_vars;
   unsigned int num_classes;
@@ -2981,6 +2993,8 @@ typedef struct _dwg_struct
 int
 dwg_read_file(char *filename, Dwg_Data * dwg);
 
+char * dwg_version_code (Dwg_Data * dwg);
+
 #ifdef USE_WRITE
 int
 dwg_write_file(char *filename, Dwg_Data * dwg_data);
diff --git a/src/dwg.spec b/src/dwg.spec
index cb04a27..70552de 100644
--- a/src/dwg.spec
+++ b/src/dwg.spec
@@ -1,7 +1,7 @@
 /*****************************************************************************/
 /*  LibreDWG - free implementation of the DWG file format                    */
 /*                                                                           */
-/*  Copyright (C) 2009, 2010 Free Software Foundation, Inc.                  */
+/*  Copyright (C) 2009, 2010, 2013 Free Software Foundation, Inc.            */
 /*                                                                           */
 /*  This library is free software, licensed under the terms of the GNU       */
 /*  General Public License as published by the Free Software Foundation,     */
@@ -13,26 +13,18 @@
 /**
  *     \file       dwg.spec
  *     \brief      DWG entities and objects specification
- *     \author     written by Felipe Castro
+ *     \author     written and modified by Felipe Castro
  *     \author     modified by Rodrigo Rodrigues da Silva
  *     \author     modified by Till Heuschmann
  *     \version    
  *     \copyright  GNU General Public License (version 3 or later)
  */
 
-#ifdef IS_ENCODER
-#define ENCODER if (1)
-#define DECODER if (0)
-#endif
-
-#ifdef IS_DECODER
-#define ENCODER if (0)
-#define DECODER if (1)
-#endif
-
 #ifdef IS_PRINT
-#define ENCODER if (0)
-#define DECODER if (0)
+#  undef IS_ENCODER
+#  ifndef IS_DECODER
+#    define IS_DECODER
+#  endif
 #endif
 
 #define TODO_ENCODER fprintf(stderr, "TODO: Encoder\n");
@@ -338,7 +330,7 @@ DWG_ENTITY(INSERT);
 
   SINCE(R_2000)
     {
-      DECODER
+#     ifdef IS_DECODER
         {
           FIELD(scale_flag, BB);
           if (FIELD_VALUE(scale_flag) == 3)
@@ -366,8 +358,9 @@ DWG_ENTITY(INSERT);
               FIELD_DD(scale.z, FIELD_VALUE(scale.x));
             }
         }
+#     endif
 
-      ENCODER
+#     ifdef IS_ENCODER
         {
           if (FIELD_VALUE(scale.x)==1.0 && FIELD_VALUE(scale.y)==1.0 && FIELD_VALUE(scale.z)==1.0)
             {
@@ -396,7 +389,8 @@ DWG_ENTITY(INSERT);
               FIELD_DD(scale.y, FIELD_VALUE(scale.x));
               FIELD_DD(scale.z, FIELD_VALUE(scale.x));
             }
-        }
+       }
+#    endif
     }
 
   FIELD(rotation_ang, BD);
@@ -455,7 +449,7 @@ DWG_ENTITY(MINSERT);
 
   SINCE(R_2000)
     {
-      DECODER
+#     ifdef IS_DECODER
         {
           FIELD(scale_flag, BB);
           if (FIELD_VALUE(scale_flag) == 3){
@@ -480,8 +474,9 @@ DWG_ENTITY(MINSERT);
               FIELD_DD(scale.z, FIELD_VALUE(scale.x));
             }
         }
+#     endif
 
-      ENCODER
+#     ifdef IS_ENCODER
         {
           if (FIELD_VALUE(scale.x) == FIELD_VALUE(scale.y) == FIELD_VALUE(scale.z) == 1.0)
             {
@@ -510,6 +505,7 @@ DWG_ENTITY(MINSERT);
               FIELD_DD(scale.z, FIELD_VALUE(scale.x));
              }
         }
+#     endif
     }
 
   FIELD(rotation_ang, BD);
@@ -564,7 +560,7 @@ DWG_ENTITY(VERTEX_2D);
 data when saving. So we explicitely implemented the encoder routine with the
 compression technique described in the spec. --Juca */
 
-  DECODER
+# ifdef IS_DECODER
     {
       FIELD(start_width, BD);
  
@@ -578,8 +574,9 @@ compression technique described in the spec. --Juca */
           FIELD(end_width, BD);
         }
     }
+# endif
 
-  ENCODER
+# ifdef IS_ENCODER
     {
       if (FIELD_VALUE(start_width) && FIELD_VALUE(start_width)==FIELD_VALUE(end_width))
         {
@@ -594,6 +591,7 @@ compression technique described in the spec. --Juca */
           FIELD(end_width, BD);
         }
     }
+# endif
 
   FIELD(bulge, BD);
   FIELD(tangent_dir, BD);
@@ -742,7 +740,7 @@ DWG_ENTITY(LINE);
 
   SINCE(R_2000)
     {
-      DECODER
+#     ifdef IS_DECODER
         {
           FIELD(Zs_are_zero, B);
           FIELD(start.x, RD);
@@ -761,8 +759,9 @@ DWG_ENTITY(LINE);
               FIELD_DD(end.z, FIELD_VALUE(start.z));
             }
         }
+#     endif
 
-      ENCODER
+#     ifdef IS_ENCODER
         {
           FIELD_VALUE(Zs_are_zero) = (FIELD_VALUE(start.z) == 0.0 && FIELD_VALUE(end.z) == 0.0);
           FIELD_B(Zs_are_zero);
@@ -776,6 +775,7 @@ DWG_ENTITY(LINE);
               FIELD_DD(end.z, FIELD_VALUE(start.z));
             }
         }
+#     endif
     }
 
   FIELD(thickness, BT);
@@ -956,7 +956,7 @@ DWG_ENTITY(_3DFACE);
     {
       FIELD_B(has_no_flags);
 
-      DECODER
+#     ifdef IS_DECODER
         {
           FIELD_B(z_is_zero);
           FIELD_RD(corner1.x);
@@ -970,8 +970,9 @@ DWG_ENTITY(_3DFACE);
               FIELD_RD(corner1.z);
             }
         }
+#     endif
 
-      ENCODER
+#     ifdef IS_ENCODER
         {
           FIELD_VALUE(z_is_zero) = (FIELD_VALUE(corner1.z) == 0);
           FIELD_B(z_is_zero);
@@ -982,6 +983,7 @@ DWG_ENTITY(_3DFACE);
               FIELD_RD(corner1.z);
             }
         }
+#     endif
 
       FIELD_DD(corner2.x, FIELD_VALUE(corner1.x));
       FIELD_DD(corner2.y, FIELD_VALUE(corner1.y));
@@ -1258,18 +1260,19 @@ DWG_ENTITY_END
       FIELD_B(name.has_shear);                        \
     }
 
+#ifndef IS_PRINT
 #ifdef IS_DECODER
 
 #define DECODE_3DSOLID decode_3dsolid(dat, obj, _obj);
 
 void decode_3dsolid(Bit_Chain* dat, Dwg_Object* obj, Dwg_Entity_3DSOLID* _obj){
 	Dwg_Data* dwg = obj->parent;
-  int vcount, rcount, rcount2;
-  int i=0;
-  int j=0;
+  unsigned int vcount, rcount, rcount2;
+  unsigned int i=0;
+  unsigned int j=0;
   int index;
   int total_size=0;
-  int num_blocks=0;
+  unsigned int num_blocks=0;
   FIELD_B(acis_empty);
   
   if (!FIELD_VALUE(acis_empty))
@@ -1375,6 +1378,9 @@ void decode_3dsolid(Bit_Chain* dat, Dwg_Object* obj, Dwg_Entity_3DSOLID* _obj){
 #else
 #define DECODE_3DSOLID {}
 #endif //#if IS_DECODER
+#else
+#define DECODE_3DSOLID {}
+#endif //#if IS_PRINT
 
 #ifdef IS_ENCODER
 
@@ -1390,38 +1396,32 @@ void encode_3dsolid(Bit_Chain* dat, Dwg_Object* obj, Dwg_Entity_3DSOLID* _obj){
 
 /*(37)*/
 DWG_ENTITY(REGION);
-  DECODER
-    {
-      DECODE_3DSOLID;
-    }
-  ENCODER
-    {
-      ENCODE_3DSOLID;
-    }
+# ifdef IS_DECODER
+    DECODE_3DSOLID;
+# endif
+# ifdef IS_ENCODER
+    ENCODE_3DSOLID;
+# endif
 DWG_ENTITY_END
 
 /*(38)*/
 DWG_ENTITY(_3DSOLID);
-  DECODER
-    {
+# ifdef IS_DECODER
       DECODE_3DSOLID;
-    }
-  ENCODER
-    {
+# endif
+# ifdef IS_ENCODER
       ENCODE_3DSOLID;
-    }
+# endif
 DWG_ENTITY_END
 
 /*(39)*/
 DWG_ENTITY(BODY);
-  DECODER
-    {
-      DECODE_3DSOLID;
-    }
-  ENCODER
-    {
-      ENCODE_3DSOLID;
-    }
+# ifdef IS_DECODER
+    DECODE_3DSOLID;
+# endif
+# ifdef IS_ENCODER
+    ENCODE_3DSOLID;
+# endif
 DWG_ENTITY_END
 
 /*(40)*/
@@ -1703,12 +1703,14 @@ DWG_OBJECT(BLOCK_HEADER);
   SINCE(R_2000)
     {
 
+#    ifndef IS_PRINT
       //skip non-zero bytes and a terminating zero:
       FIELD_VALUE(insert_count)=0;
       while (bit_read_RC(dat))
         {
           FIELD_VALUE(insert_count)++;
         }
+#    endif
 
       FIELD(block_description, TV);
 
@@ -1928,11 +1930,13 @@ DWG_OBJECT(VIEW);
   FIELD(front_clip, BD);
   FIELD(back_clip, BD);
   
+#ifndef IS_PRINT
   //FIELD(view_mode, RC); //??? 4bits
   bit_read_B(dat);
   bit_read_B(dat);
   bit_read_B(dat);
   bit_read_B(dat);
+#endif
 
   SINCE(R_2000)
     {
@@ -2146,15 +2150,16 @@ DWG_OBJECT_END
 DWG_OBJECT(DIMSTYLE_CONTROL);
 
   FIELD_BS (num_entries);
+
   SINCE(R_2000)
+    /*
+    This is not stated in the spec.
+    I've seen it in a R2000 file but not on a R14,
+    so I'll assume it is a R_2000+ field.
+    TODO: this should be checked with more sample files from various DWG versions.
+    ~Juca
+    */
     {
-      /*
-      This is not stated in the spec.
-       I've seen it in a R2000 file but not on a R14,
-       so I'll assume it is a R_2000+ field.
-      TODO: this should be checked with more sample files from various DWG versions.
-        ~Juca
-      */
       //FIELD_HANDLE (unknown_handle, ANYCODE);
       bit_read_RC(dat);  // I think it's just one byte
     }
@@ -3503,7 +3508,7 @@ DWG_ENTITY_END
 //pg.164
 DWG_OBJECT(XRECORD);
 
-  DECODER
+# ifndef IS_DECODER
     {
 	  FIELD_BL(numdatabytes);  	    
 	  FIELD_XDATA(rbuf, numdatabytes);
@@ -3520,6 +3525,7 @@ DWG_OBJECT(XRECORD);
 	  //XXX how to known when I run out of data?
 	  //BITCODE_H* objid_handles;
     }
+# endif
     
 DWG_OBJECT_END
 
